/*
 *
 * set frequency 
 * 
 *
 * note this mosu be a 8 char string, zero padded on left 
 *
 */
 
#include "ft100.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

const char *CFREQ_TBL[256] =
{   
 "00", "01", "02", "03", "04", "05", "06", "07", "08", "09","0A","0B","0C","0D","0E", "0F",	
 "10", "11", "12", "13", "14", "15", "16", "17", "18", "19","1A","1B","1C","1D","1E", "1F",
 "20", "21", "22", "23", "24", "25", "26", "27", "28", "29","2A","2B","2C","2D","2E", "2F",
 "30", "31", "32", "33", "34", "35", "36", "37", "38", "39","3A","3B","3C","3D","3E", "3F",
 "40", "41", "42", "43", "44", "45", "46", "47", "48", "49","43","4B","4C","4D","4E", "4F",
 "50", "51", "52", "53", "54", "55", "56", "57", "58", "59","5A","5B","5C","5D","5E", "5F",
 "60", "61", "62", "63", "64", "65", "66", "67", "68", "69","6A","6B","6C","6D","6E", "6F",
 "70", "71", "72", "73", "74", "75", "76", "77", "78", "79","7A","7B","7C","7D","7E", "7F",
 "80", "81", "82", "83", "84", "85", "86", "87", "88", "89","8A","8B","8C","8D","8E", "8F",
 "90", "91", "92", "93", "94", "95", "96", "97", "98", "99","9A","9B","9C","9D","9E", "9F",
 "A0", "A1", "A2", "A3", "A4", "A5", "A6", "A7", "A8", "A9","AA","AB","AC","AD","AE", "AF",
 "B0", "B1", "B2", "B3", "B4", "B5", "B6", "B7", "B8", "B9","BA","BB","BC","BD","BE", "BF",
 "C0", "C1", "C2", "C3", "C4", "C5", "C6", "C7", "C8", "C9","CA","CB","CC","CD","CE", "CF",
 "D0", "D1", "D2", "D3", "D4", "D5", "D6", "D7", "D8", "D9","DA","DB","DC","DD","DE", "DF",
 "E0", "E1", "E2", "E3", "E4", "E5", "E6", "E7", "E8", "E9","EA","EB","EC","ED","EE", "EF",
 "F0", "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9","FA","FB","FC","FD","FE", "FF"
};


/*
 *  *
 *  * Freq Xlate Tbl
 *  *
 *  */
const char FREQ_TBL[100] =
{
   
      0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09,
        0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19,
        0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29,
        0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
        0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49,
        0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59,
        0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69,
        0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79,
        0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
        0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99
};

int ft100_set_freq(int fdSer, char *freq)
{
   FT100_CMD ft100_cmd;
   char freq_byte[2];
   char freq_string[9];
   int  f[9];
   int  l,i,j;
   
   
   l=strlen(freq);
   // printf("Len of input string is %i\n",l);
   freq_string[8]=0x00;
   j=7;
   for(i=l; i > -1;)
     {
	if (isdigit(freq[i]))
	  {	     
            freq_string[j]=freq[i];
            j--;
	  }
	  i--;
     }
   
   for(i=j; i> -1; i--)
     freq_string[i]='0';
   
   for (i=0; i<8; i++)
       {  
	 freq_byte[1]=0x00;
	 freq_byte[0]=freq_string[i];
	 f[i]=atoi(freq_byte);
       }
   
   
   ft100_cmd.p4=FREQ_TBL[10*f[0]+f[1]];
   ft100_cmd.p3=FREQ_TBL[10*f[2]+f[3]];
   ft100_cmd.p2=FREQ_TBL[10*f[4]+f[5]];
   ft100_cmd.p1=FREQ_TBL[10*f[6]+f[7]];
   ft100_cmd.opcode=SET_FREQ;
   
   return(put_ft100_cmd(fdSer, &ft100_cmd));
}



unsigned long int cnvrt_freq(unsigned char *freq)
{
   unsigned long int d1, d2;
   char freq_str[20];  
   int i,j;
   
   for (i=0; i<20; i++ )
      freq_str[i]=0x00;

   for (i=0; i<4; i++)
     {
	j=(int)freq[i];
        strcat(freq_str, CFREQ_TBL[j]);
     }
   
   
   d1=strtoul(freq_str,NULL,16);
   d2=d1*1.25;
   return(d2/10);
}

