/*
 * 
 * Version
 * 
 */

#define VERSION "Version is ft100-0.0.7 \n"



/*
 * 
 * structure headers for Yeasu FT100
 * 
 */


typedef struct 
{
   char p1;
   char p2;
   char p3;
   char p4;
   char opcode;
}
 FT100_CMD;

typedef struct
{
   char band_no;
   char freq[4];
   char mode;
   char ctcss;
   char dcs;
   char flag1;
   char flag2;
   char clarifier[2];
   char not_used;
   char step1;
   char step2;
   char filter;
   char status_flags[8];
}
 FT100_STATUS;


typedef struct 
{
   char mic_switch_1;
   char tx_fwd_power;
   char tx_rev_power;
   char s_meter;
   char mic_level;
   char squelch_level;
   char mic_switch_2;
   char final_temp;
   char alc_level;
}
 FT100_METER;

/*
 *
 * 
 * Opcode and parm values
 * 
 * 
 */

#define SET_SPLIT 0x01
#define SPLIT_ON 0x01
#define SPLIT_OFF 0x00

#define SET_VFO 0x05
#define VFO_A 0x00
#define VFO_B 0x01

#define SET_FREQ 0x0a

#define SET_MODE 0x0c
#define MODE_LSB 0x00
#define MODE_USB 0x01
#define MODE_CW 0x02
#define MODE_CWR 0x03
#define MODE_AM 0x04
#define MODE_DIG 0x05
#define MODE_FM 0x06
#define MODE_WFM 0x07

#define SET_PTT 0x0f
#define PTT_OFF 0x00
#define PTT_ON 0x01

#define UPDATE_STATUS 0x10

#define SET_SHIFT 0x84
#define SHIFT_SIMPLEX 0x00
#define SHIFT_MINUS 0x01
#define SHIFT_PLUS 0x02

#define SET_FILTER 0x8c
#define FILTER_24K 0x02
#define FILTER_6K 0x03
#define FILTER_500 0x01
#define FILTER_300 0x00

#define SET_CTCSS_TONE 0x90

#define SET_DCS_CODE 0x91

#define SET_CTCSS_DCS_MODE 0x92
#define CTCSS_DCS_OFF 0x00
#define CTCSS_ENC_ON 0x01
#define CTCSS_TENC_DEC_ON 0x02
#define DCS_ON 0x03

#define READ_METER 0xf7

#define READ_STATUS_FLAGS 0xfa


/*
 *
 * function defs
 *
 */
 
void show_help(void);

int put_ft100_cmd(int fdSer, FT100_CMD *ft100_cmd);

int ft100_set_mode(int fdSer, char *mode);
int ft100_set_freq(int fdSer, char *freq);
int ft100_set_ctcss(int fdSer, char *tone);
int ft100_set_ctcss_pl(int fdSer, char *tone);
int ft100_set_dcs(int fdSer, char *code);
int ft100_set_vfo(int fdSer, char *vfo);
int ft100_set_split(int fdSer, char *split);
int ft100_set_dcs_ctcss_mode(int fdSer, char *mode);
int ft100_set_repeater_shift(int fdSer, char *shift);
int ft100_set_ptt(int fdSer, char *ptt);
int ft100_set_filter(int fdSer, char *filter);
unsigned long int cnvrt_freq(unsigned char *freq);

int ft100_read_status(char *device, int fdSer, FT100_STATUS *ft100_status);
void ft100_show_status(FT100_STATUS ft100_status);

int ft100_read_meter(char * device, int fdSer, FT100_METER *ft100_meter);
void ft100_show_meter(FT100_METER ft100_meter);

char *cnvrt_tone(int tone_idx);
char *cnvrt_dcs(int tond_idx);
void unpkflags(unsigned char c, int *flags);
